package gcw.gcw5.step0;

import gcw.gcw5.util.ByteArray;

import java.io.File;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import org.apache.commons.io.FileUtils;
import org.apache.commons.lang.StringUtils;

/**
 * Step0:すごくべたに書いてみる(クラス化(Step1)より前)
 */
public class Main {
	public static void main(String[] args) throws Exception {
		byte[] messages = FileUtils.readFileToByteArray(new File("data.txt"));
		ByteArray bytes = new ByteArray(messages);
		int index = 0;
		while (index < bytes.getLength() - 1) {
			Map<String, Object> record = new HashMap<String, Object>();
			record.put("送信日", toDate(bytes.getString(index, 8)));
			index += 8;
			record.put("ユーザ名", trim(bytes.getString(index, 10)));
			index += 10;
			record.put("メールアドレス", trim(bytes.getString(index, 20)));
			index += 20;
			record.put("ポイント", toInt(trim(bytes.getString(index, 5))));
			index += 5;
			System.out.println(record);
		}
	}

	private static Integer toInt(String value) {
		return Integer.parseInt(value);
	}

	private static String trim(String value) {
		return StringUtils.trim(value);
	}

	private static Date toDate(String value) {
		try {
			return new SimpleDateFormat("yyyyMMdd").parse(value);
		} catch (ParseException e) {
			throw new RuntimeException(e);
		}
	}
}
